import nltk, re, pprint

tagged_tokens = [("the", "DT"), ("little", "JJ"), ("yellow", "JJ"), 
("dog", "NN"), ("barked", "VBD"), ("at", "IN"),  ("the", "DT"), ("cat", "NN")]

cp = nltk.RegexpParser("NP: {<DT>?<JJ>*<NN>}")

cp.parse(tagged_tokens).draw()

print cp.parse(tagged_tokens)

nouns = [("money", "NN"), ("market", "NN"), ("fund", "NN")]
grammar = "NP: {<NN><NN>}  # Chunk two consecutive nouns"
cp = nltk.RegexpParser(grammar)
print cp.parse(nouns)

print cp1.parse(tagged_tokens, trace=1)

print cp2.parse(tagged_tokens, trace=1)

grammar = (r"""
   NX: {<AT|AP|PP\$>?<JJ.*>?<NN.*>}  # Chunk article/numeral/possessive+adj+noun
       {<NP>+}                       # Chunk one or more proper nouns                   
""")
cp = nltk.RegexpParser(grammar)
sent = nltk.corpus.brown.tagged_sents(categories='a')[112]
print cp.parse(sent)



text = '''
he PRP B-NP
accepted VBD B-VP
the DT B-NP
position NN I-NP
of IN B-PP
vice NN B-NP
chairman NN I-NP
of IN B-PP
Carlyle NNP B-NP
Group NNP I-NP
, , O
a DT B-NP
merchant NN I-NP
banking NN I-NP
concern NN I-NP
. . O
'''
nltk.chunk.conllstr2tree(text, chunk_types=('NP',)).draw()

print nltk.corpus.conll2000.chunked_sents('train.txt')[99]

print nltk.corpus.conll2000.chunked_sents('train.txt', chunk_types=('NP',))[99]

cp = nltk.RegexpParser("")
print nltk.chunk.accuracy(cp, nltk.corpus.conll2000.chunked_sents('train.txt', chunk_types=('NP',)))

grammar = r"NP: {<[CDJNP].*>+}"
cp = nltk.RegexpParser(grammar)
print nltk.chunk.accuracy(cp, nltk.corpus.conll2000.chunked_sents('train.txt', chunk_types=('NP',)))

train_sents = nltk.corpus.conll2000.chunked_sents('train.txt', chunk_types=('NP',))
print chunked_tags(train_sents)

train_sents = nltk.corpus.conll2000.chunked_sents('train.txt', chunk_types=('NP',))
test_sents  = nltk.corpus.conll2000.chunked_sents('test.txt', chunk_types=('NP',))
cp = baseline_chunker(train_sents)
print nltk.chunk.accuracy(cp, test_sents)

print cp.parse(tagged_tokens)

test_sents = nltk.corpus.conll2000.chunked_sents('test.txt', chunk_types=('NP',))
print nltk.chunk.accuracy(cp, test_sents)

example = nltk.corpus.conll2000.chunked_sents('train.txt')[99]
print example

print example.flatten()

example = nltk.corpus.conll2000.chunked_sents('train.txt')[99]
print cp.parse(example.flatten(), trace=1)

correct = nltk.chunk.tagstr2tree(
   "[ the/DT little/JJ cat/NN ] sat/VBD on/IN [ the/DT mat/NN ]")
print correct.flatten()

grammar = r"NP: {<PRP|DT|POS|JJ|CD|N.*>+}"
cp = nltk.RegexpParser(grammar)
tagged_tokens = [("the", "DT"), ("little", "JJ"), ("cat", "NN"),
("sat", "VBD"), ("on", "IN"), ("the", "DT"), ("mat", "NN")]
chunkscore = nltk.chunk.ChunkScore()
guess = cp.parse(correct.flatten())
chunkscore.score(correct, guess)
print chunkscore

grammar = r"NP: {<DT|JJ|NN>+}"
cp = nltk.RegexpParser(grammar)
chunkscore = nltk.chunk.ChunkScore()
for file in nltk.corpus.treebank_chunk.files()[:5]:
    for chunk_struct in nltk.corpus.treebank_chunk.chunked_sents(file):
        test_sent = cp.parse(chunk_struct.flatten())
        chunkscore.score(chunk_struct, test_sent)
print chunkscore

from random import shuffle
missed = chunkscore.missed()
shuffle(missed)
print missed[:10]

incorrect = chunkscore.incorrect()
shuffle(incorrect)

chunkscore = nltk.chunk.ChunkScore(max_fp_examples=1000,
                                   max_fn_examples=1000)

chunk_data = [[(t,c) for w,t,c in nltk.chunk.tree2conlltags(chtree)]
             for chtree in nltk.corpus.conll2000.chunked_sents('train.txt')]

unigram_chunker = nltk.UnigramTagger(chunk_data)
print nltk.tag.accuracy(unigram_chunker, chunk_data)

bigram_chunker = nltk.BigramTagger(chunk_data, backoff=unigram_chunker)
print nltk.tag.accuracy(bigram_chunker, chunk_data)

print cp.parse(tagged_tokens)

tagged_tokens = [("John", "NNP"), ("thinks", "VBZ"), ("Mary", "NN"),
    ("saw", "VBD"), ("the", "DT"), ("cat", "NN"), ("sit", "VB"),
    ("on", "IN"), ("the", "DT"), ("mat", "NN")]
print cp.parse(tagged_tokens)

cp = nltk.RegexpParser(grammar, loop=2)
print cp.parse(tagged_tokens)

IN = re.compile(r'.*\bin\b(?!\b.+ing\b)')
for doc in nltk.corpus.ieer.parsed_docs('NYT_19980315'):
    for rel in nltk.sem.extract_rels('ORG', 'LOC', doc, pattern = IN):
        print nltk.sem.show_raw_rtuple(rel)

vnv = """
(
is/V|
was/V|
werd/V|
wordt/V
)
.*
van/Prep
"""
VAN = re.compile(vnv, re.VERBOSE)
for r in nltk.sem.extract_rels('PER', 'ORG', corpus='conll2002-ned', pattern=VAN): 
    print show_tuple(r)

